<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleConfigurationDiagnostics StructType
 * @subpackage Structs
 */
class VehicleConfigurationDiagnostics extends AbstractStructBase
{
    /**
     * The UniqueSerialID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UniqueSerialID;
    /**
     * The Pincode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Pincode;
    /**
     * The SecurityIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SecurityIdentifier;
    /**
     * The PasswordGsmData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PasswordGsmData;
    /**
     * The PasswordGPRS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PasswordGPRS;
    /**
     * The BoardHWVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BoardHWVersion;
    /**
     * The Version
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Version;
    /**
     * The CurrentRom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CurrentRom;
    /**
     * The RamHomeNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RamHomeNumber;
    /**
     * The FirmwareVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FirmwareVersion;
    /**
     * The OSVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OSVersion;
    /**
     * The ImageVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ImageVersion;
    /**
     * The EPromVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EPromVersion;
    /**
     * The BootloaderVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BootloaderVersion;
    /**
     * The CPLDVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CPLDVersion;
    /**
     * The IVVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IVVersion;
    /**
     * The ISSubversion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ISSubversion;
    /**
     * The CanVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CanVersion;
    /**
     * The UniversalTachoInterfaceVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UniversalTachoInterfaceVersion;
    /**
     * The BootloaderMajorMinor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BootloaderMajorMinor;
    /**
     * The ApplicationMajorMinor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ApplicationMajorMinor;
    /**
     * The CompactUnitVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CompactUnitVersion;
    /**
     * The PlanningReadConfirmation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PlanningReadConfirmation;
    /**
     * The SpeedSource
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SpeedSource;
    /**
     * The RpmSource
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RpmSource;
    /**
     * The PulsSettingIndication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PulsSettingIndication;
    /**
     * The PulsSettingValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PulsSettingValue;
    /**
     * The PulsSettingMileageLastChanged
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PulsSettingMileageLastChanged;
    /**
     * The PulSettingDateTimeLastChange
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PulSettingDateTimeLastChange;
    /**
     * The KmProtocolSetting
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KmProtocolSetting;
    /**
     * The VKFreeNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VKFreeNumber;
    /**
     * The VKRefuseIncoming
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VKRefuseIncoming;
    /**
     * The VKRefuseCalling
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VKRefuseCalling;
    /**
     * The ComPorts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ComPorts;
    /**
     * The ObcLoudness
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ObcLoudness;
    /**
     * The TechParamFile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TechParamFile;
    /**
     * The TachoStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TachoStatus;
    /**
     * The RibasVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasVersion;
    /**
     * The RibasRevvingWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasRevvingWarning;
    /**
     * The RibasRevvingMax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasRevvingMax;
    /**
     * The RibasIdlingWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasIdlingWarning;
    /**
     * The RibasIdlingMax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasIdlingMax;
    /**
     * The RibasBrakingWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasBrakingWarning;
    /**
     * The RibasBrakingMax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasBrakingMax;
    /**
     * The RibasAccelerationWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasAccelerationWarning;
    /**
     * The RibasAccelerationMax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasAccelerationMax;
    /**
     * The RibasSpeedWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasSpeedWarning;
    /**
     * The RibasSpeedMax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RibasSpeedMax;
    /**
     * The PlanningCleaningVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PlanningCleaningVersion;
    /**
     * The PlanningCleaningTimeoutNotCheckedOff
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PlanningCleaningTimeoutNotCheckedOff;
    /**
     * The PlanningCleaningTimeoutcheckedOff
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PlanningCleaningTimeoutcheckedOff;
    /**
     * The PopupGeofencingAlarmsVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PopupGeofencingAlarmsVersion;
    /**
     * The PopupGeofencingAlarmsStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PopupGeofencingAlarmsStatus;
    /**
     * The PopupTextMessagesVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PopupTextMessagesVersion;
    /**
     * The PopupTextMessagesStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PopupTextMessagesStatus;
    /**
     * The LoginManagerVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoginManagerVersion;
    /**
     * The LoginManagerTimeout
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoginManagerTimeout;
    /**
     * The TCGFormatVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TCGFormatVersion;
    /**
     * The TCGSameIpAsFtp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TCGSameIpAsFtp;
    /**
     * The TCGIp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TCGIp;
    /**
     * The AgrNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AgrNumber;
    /**
     * The TemperaturTopbarVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemperaturTopbarVersion;
    /**
     * The TemperatureTopbarStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemperatureTopbarStatus;
    /**
     * The SendDocumentsVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SendDocumentsVersion;
    /**
     * The SendDocumentsStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SendDocumentsStatus;
    /**
     * Constructor method for VehicleConfigurationDiagnostics
     * @uses VehicleConfigurationDiagnostics::setUniqueSerialID()
     * @uses VehicleConfigurationDiagnostics::setPincode()
     * @uses VehicleConfigurationDiagnostics::setSecurityIdentifier()
     * @uses VehicleConfigurationDiagnostics::setPasswordGsmData()
     * @uses VehicleConfigurationDiagnostics::setPasswordGPRS()
     * @uses VehicleConfigurationDiagnostics::setBoardHWVersion()
     * @uses VehicleConfigurationDiagnostics::setVersion()
     * @uses VehicleConfigurationDiagnostics::setCurrentRom()
     * @uses VehicleConfigurationDiagnostics::setRamHomeNumber()
     * @uses VehicleConfigurationDiagnostics::setFirmwareVersion()
     * @uses VehicleConfigurationDiagnostics::setOSVersion()
     * @uses VehicleConfigurationDiagnostics::setImageVersion()
     * @uses VehicleConfigurationDiagnostics::setEPromVersion()
     * @uses VehicleConfigurationDiagnostics::setBootloaderVersion()
     * @uses VehicleConfigurationDiagnostics::setCPLDVersion()
     * @uses VehicleConfigurationDiagnostics::setIVVersion()
     * @uses VehicleConfigurationDiagnostics::setISSubversion()
     * @uses VehicleConfigurationDiagnostics::setCanVersion()
     * @uses VehicleConfigurationDiagnostics::setUniversalTachoInterfaceVersion()
     * @uses VehicleConfigurationDiagnostics::setBootloaderMajorMinor()
     * @uses VehicleConfigurationDiagnostics::setApplicationMajorMinor()
     * @uses VehicleConfigurationDiagnostics::setCompactUnitVersion()
     * @uses VehicleConfigurationDiagnostics::setPlanningReadConfirmation()
     * @uses VehicleConfigurationDiagnostics::setSpeedSource()
     * @uses VehicleConfigurationDiagnostics::setRpmSource()
     * @uses VehicleConfigurationDiagnostics::setPulsSettingIndication()
     * @uses VehicleConfigurationDiagnostics::setPulsSettingValue()
     * @uses VehicleConfigurationDiagnostics::setPulsSettingMileageLastChanged()
     * @uses VehicleConfigurationDiagnostics::setPulSettingDateTimeLastChange()
     * @uses VehicleConfigurationDiagnostics::setKmProtocolSetting()
     * @uses VehicleConfigurationDiagnostics::setVKFreeNumber()
     * @uses VehicleConfigurationDiagnostics::setVKRefuseIncoming()
     * @uses VehicleConfigurationDiagnostics::setVKRefuseCalling()
     * @uses VehicleConfigurationDiagnostics::setComPorts()
     * @uses VehicleConfigurationDiagnostics::setObcLoudness()
     * @uses VehicleConfigurationDiagnostics::setTechParamFile()
     * @uses VehicleConfigurationDiagnostics::setTachoStatus()
     * @uses VehicleConfigurationDiagnostics::setRibasVersion()
     * @uses VehicleConfigurationDiagnostics::setRibasRevvingWarning()
     * @uses VehicleConfigurationDiagnostics::setRibasRevvingMax()
     * @uses VehicleConfigurationDiagnostics::setRibasIdlingWarning()
     * @uses VehicleConfigurationDiagnostics::setRibasIdlingMax()
     * @uses VehicleConfigurationDiagnostics::setRibasBrakingWarning()
     * @uses VehicleConfigurationDiagnostics::setRibasBrakingMax()
     * @uses VehicleConfigurationDiagnostics::setRibasAccelerationWarning()
     * @uses VehicleConfigurationDiagnostics::setRibasAccelerationMax()
     * @uses VehicleConfigurationDiagnostics::setRibasSpeedWarning()
     * @uses VehicleConfigurationDiagnostics::setRibasSpeedMax()
     * @uses VehicleConfigurationDiagnostics::setPlanningCleaningVersion()
     * @uses VehicleConfigurationDiagnostics::setPlanningCleaningTimeoutNotCheckedOff()
     * @uses VehicleConfigurationDiagnostics::setPlanningCleaningTimeoutcheckedOff()
     * @uses VehicleConfigurationDiagnostics::setPopupGeofencingAlarmsVersion()
     * @uses VehicleConfigurationDiagnostics::setPopupGeofencingAlarmsStatus()
     * @uses VehicleConfigurationDiagnostics::setPopupTextMessagesVersion()
     * @uses VehicleConfigurationDiagnostics::setPopupTextMessagesStatus()
     * @uses VehicleConfigurationDiagnostics::setLoginManagerVersion()
     * @uses VehicleConfigurationDiagnostics::setLoginManagerTimeout()
     * @uses VehicleConfigurationDiagnostics::setTCGFormatVersion()
     * @uses VehicleConfigurationDiagnostics::setTCGSameIpAsFtp()
     * @uses VehicleConfigurationDiagnostics::setTCGIp()
     * @uses VehicleConfigurationDiagnostics::setAgrNumber()
     * @uses VehicleConfigurationDiagnostics::setTemperaturTopbarVersion()
     * @uses VehicleConfigurationDiagnostics::setTemperatureTopbarStatus()
     * @uses VehicleConfigurationDiagnostics::setSendDocumentsVersion()
     * @uses VehicleConfigurationDiagnostics::setSendDocumentsStatus()
     * @param string $uniqueSerialID
     * @param string $pincode
     * @param string $securityIdentifier
     * @param string $passwordGsmData
     * @param string $passwordGPRS
     * @param string $boardHWVersion
     * @param string $version
     * @param string $currentRom
     * @param string $ramHomeNumber
     * @param string $firmwareVersion
     * @param string $oSVersion
     * @param string $imageVersion
     * @param string $ePromVersion
     * @param string $bootloaderVersion
     * @param string $cPLDVersion
     * @param string $iVVersion
     * @param string $iSSubversion
     * @param string $canVersion
     * @param string $universalTachoInterfaceVersion
     * @param string $bootloaderMajorMinor
     * @param string $applicationMajorMinor
     * @param string $compactUnitVersion
     * @param string $planningReadConfirmation
     * @param string $speedSource
     * @param string $rpmSource
     * @param string $pulsSettingIndication
     * @param string $pulsSettingValue
     * @param string $pulsSettingMileageLastChanged
     * @param string $pulSettingDateTimeLastChange
     * @param string $kmProtocolSetting
     * @param string $vKFreeNumber
     * @param string $vKRefuseIncoming
     * @param string $vKRefuseCalling
     * @param string $comPorts
     * @param string $obcLoudness
     * @param string $techParamFile
     * @param string $tachoStatus
     * @param string $ribasVersion
     * @param string $ribasRevvingWarning
     * @param string $ribasRevvingMax
     * @param string $ribasIdlingWarning
     * @param string $ribasIdlingMax
     * @param string $ribasBrakingWarning
     * @param string $ribasBrakingMax
     * @param string $ribasAccelerationWarning
     * @param string $ribasAccelerationMax
     * @param string $ribasSpeedWarning
     * @param string $ribasSpeedMax
     * @param string $planningCleaningVersion
     * @param string $planningCleaningTimeoutNotCheckedOff
     * @param string $planningCleaningTimeoutcheckedOff
     * @param string $popupGeofencingAlarmsVersion
     * @param string $popupGeofencingAlarmsStatus
     * @param string $popupTextMessagesVersion
     * @param string $popupTextMessagesStatus
     * @param string $loginManagerVersion
     * @param string $loginManagerTimeout
     * @param string $tCGFormatVersion
     * @param string $tCGSameIpAsFtp
     * @param string $tCGIp
     * @param string $agrNumber
     * @param string $temperaturTopbarVersion
     * @param string $temperatureTopbarStatus
     * @param string $sendDocumentsVersion
     * @param string $sendDocumentsStatus
     */
    public function __construct($uniqueSerialID = null, $pincode = null, $securityIdentifier = null, $passwordGsmData = null, $passwordGPRS = null, $boardHWVersion = null, $version = null, $currentRom = null, $ramHomeNumber = null, $firmwareVersion = null, $oSVersion = null, $imageVersion = null, $ePromVersion = null, $bootloaderVersion = null, $cPLDVersion = null, $iVVersion = null, $iSSubversion = null, $canVersion = null, $universalTachoInterfaceVersion = null, $bootloaderMajorMinor = null, $applicationMajorMinor = null, $compactUnitVersion = null, $planningReadConfirmation = null, $speedSource = null, $rpmSource = null, $pulsSettingIndication = null, $pulsSettingValue = null, $pulsSettingMileageLastChanged = null, $pulSettingDateTimeLastChange = null, $kmProtocolSetting = null, $vKFreeNumber = null, $vKRefuseIncoming = null, $vKRefuseCalling = null, $comPorts = null, $obcLoudness = null, $techParamFile = null, $tachoStatus = null, $ribasVersion = null, $ribasRevvingWarning = null, $ribasRevvingMax = null, $ribasIdlingWarning = null, $ribasIdlingMax = null, $ribasBrakingWarning = null, $ribasBrakingMax = null, $ribasAccelerationWarning = null, $ribasAccelerationMax = null, $ribasSpeedWarning = null, $ribasSpeedMax = null, $planningCleaningVersion = null, $planningCleaningTimeoutNotCheckedOff = null, $planningCleaningTimeoutcheckedOff = null, $popupGeofencingAlarmsVersion = null, $popupGeofencingAlarmsStatus = null, $popupTextMessagesVersion = null, $popupTextMessagesStatus = null, $loginManagerVersion = null, $loginManagerTimeout = null, $tCGFormatVersion = null, $tCGSameIpAsFtp = null, $tCGIp = null, $agrNumber = null, $temperaturTopbarVersion = null, $temperatureTopbarStatus = null, $sendDocumentsVersion = null, $sendDocumentsStatus = null)
    {
        $this
            ->setUniqueSerialID($uniqueSerialID)
            ->setPincode($pincode)
            ->setSecurityIdentifier($securityIdentifier)
            ->setPasswordGsmData($passwordGsmData)
            ->setPasswordGPRS($passwordGPRS)
            ->setBoardHWVersion($boardHWVersion)
            ->setVersion($version)
            ->setCurrentRom($currentRom)
            ->setRamHomeNumber($ramHomeNumber)
            ->setFirmwareVersion($firmwareVersion)
            ->setOSVersion($oSVersion)
            ->setImageVersion($imageVersion)
            ->setEPromVersion($ePromVersion)
            ->setBootloaderVersion($bootloaderVersion)
            ->setCPLDVersion($cPLDVersion)
            ->setIVVersion($iVVersion)
            ->setISSubversion($iSSubversion)
            ->setCanVersion($canVersion)
            ->setUniversalTachoInterfaceVersion($universalTachoInterfaceVersion)
            ->setBootloaderMajorMinor($bootloaderMajorMinor)
            ->setApplicationMajorMinor($applicationMajorMinor)
            ->setCompactUnitVersion($compactUnitVersion)
            ->setPlanningReadConfirmation($planningReadConfirmation)
            ->setSpeedSource($speedSource)
            ->setRpmSource($rpmSource)
            ->setPulsSettingIndication($pulsSettingIndication)
            ->setPulsSettingValue($pulsSettingValue)
            ->setPulsSettingMileageLastChanged($pulsSettingMileageLastChanged)
            ->setPulSettingDateTimeLastChange($pulSettingDateTimeLastChange)
            ->setKmProtocolSetting($kmProtocolSetting)
            ->setVKFreeNumber($vKFreeNumber)
            ->setVKRefuseIncoming($vKRefuseIncoming)
            ->setVKRefuseCalling($vKRefuseCalling)
            ->setComPorts($comPorts)
            ->setObcLoudness($obcLoudness)
            ->setTechParamFile($techParamFile)
            ->setTachoStatus($tachoStatus)
            ->setRibasVersion($ribasVersion)
            ->setRibasRevvingWarning($ribasRevvingWarning)
            ->setRibasRevvingMax($ribasRevvingMax)
            ->setRibasIdlingWarning($ribasIdlingWarning)
            ->setRibasIdlingMax($ribasIdlingMax)
            ->setRibasBrakingWarning($ribasBrakingWarning)
            ->setRibasBrakingMax($ribasBrakingMax)
            ->setRibasAccelerationWarning($ribasAccelerationWarning)
            ->setRibasAccelerationMax($ribasAccelerationMax)
            ->setRibasSpeedWarning($ribasSpeedWarning)
            ->setRibasSpeedMax($ribasSpeedMax)
            ->setPlanningCleaningVersion($planningCleaningVersion)
            ->setPlanningCleaningTimeoutNotCheckedOff($planningCleaningTimeoutNotCheckedOff)
            ->setPlanningCleaningTimeoutcheckedOff($planningCleaningTimeoutcheckedOff)
            ->setPopupGeofencingAlarmsVersion($popupGeofencingAlarmsVersion)
            ->setPopupGeofencingAlarmsStatus($popupGeofencingAlarmsStatus)
            ->setPopupTextMessagesVersion($popupTextMessagesVersion)
            ->setPopupTextMessagesStatus($popupTextMessagesStatus)
            ->setLoginManagerVersion($loginManagerVersion)
            ->setLoginManagerTimeout($loginManagerTimeout)
            ->setTCGFormatVersion($tCGFormatVersion)
            ->setTCGSameIpAsFtp($tCGSameIpAsFtp)
            ->setTCGIp($tCGIp)
            ->setAgrNumber($agrNumber)
            ->setTemperaturTopbarVersion($temperaturTopbarVersion)
            ->setTemperatureTopbarStatus($temperatureTopbarStatus)
            ->setSendDocumentsVersion($sendDocumentsVersion)
            ->setSendDocumentsStatus($sendDocumentsStatus);
    }
    /**
     * Get UniqueSerialID value
     * @return string|null
     */
    public function getUniqueSerialID()
    {
        return $this->UniqueSerialID;
    }
    /**
     * Set UniqueSerialID value
     * @param string $uniqueSerialID
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setUniqueSerialID($uniqueSerialID = null)
    {
        // validation for constraint: string
        if (!is_null($uniqueSerialID) && !is_string($uniqueSerialID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uniqueSerialID, true), gettype($uniqueSerialID)), __LINE__);
        }
        $this->UniqueSerialID = $uniqueSerialID;
        return $this;
    }
    /**
     * Get Pincode value
     * @return string|null
     */
    public function getPincode()
    {
        return $this->Pincode;
    }
    /**
     * Set Pincode value
     * @param string $pincode
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPincode($pincode = null)
    {
        // validation for constraint: string
        if (!is_null($pincode) && !is_string($pincode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pincode, true), gettype($pincode)), __LINE__);
        }
        $this->Pincode = $pincode;
        return $this;
    }
    /**
     * Get SecurityIdentifier value
     * @return string|null
     */
    public function getSecurityIdentifier()
    {
        return $this->SecurityIdentifier;
    }
    /**
     * Set SecurityIdentifier value
     * @param string $securityIdentifier
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setSecurityIdentifier($securityIdentifier = null)
    {
        // validation for constraint: string
        if (!is_null($securityIdentifier) && !is_string($securityIdentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($securityIdentifier, true), gettype($securityIdentifier)), __LINE__);
        }
        $this->SecurityIdentifier = $securityIdentifier;
        return $this;
    }
    /**
     * Get PasswordGsmData value
     * @return string|null
     */
    public function getPasswordGsmData()
    {
        return $this->PasswordGsmData;
    }
    /**
     * Set PasswordGsmData value
     * @param string $passwordGsmData
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPasswordGsmData($passwordGsmData = null)
    {
        // validation for constraint: string
        if (!is_null($passwordGsmData) && !is_string($passwordGsmData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($passwordGsmData, true), gettype($passwordGsmData)), __LINE__);
        }
        $this->PasswordGsmData = $passwordGsmData;
        return $this;
    }
    /**
     * Get PasswordGPRS value
     * @return string|null
     */
    public function getPasswordGPRS()
    {
        return $this->PasswordGPRS;
    }
    /**
     * Set PasswordGPRS value
     * @param string $passwordGPRS
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPasswordGPRS($passwordGPRS = null)
    {
        // validation for constraint: string
        if (!is_null($passwordGPRS) && !is_string($passwordGPRS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($passwordGPRS, true), gettype($passwordGPRS)), __LINE__);
        }
        $this->PasswordGPRS = $passwordGPRS;
        return $this;
    }
    /**
     * Get BoardHWVersion value
     * @return string|null
     */
    public function getBoardHWVersion()
    {
        return $this->BoardHWVersion;
    }
    /**
     * Set BoardHWVersion value
     * @param string $boardHWVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setBoardHWVersion($boardHWVersion = null)
    {
        // validation for constraint: string
        if (!is_null($boardHWVersion) && !is_string($boardHWVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($boardHWVersion, true), gettype($boardHWVersion)), __LINE__);
        }
        $this->BoardHWVersion = $boardHWVersion;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->Version = $version;
        return $this;
    }
    /**
     * Get CurrentRom value
     * @return string|null
     */
    public function getCurrentRom()
    {
        return $this->CurrentRom;
    }
    /**
     * Set CurrentRom value
     * @param string $currentRom
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setCurrentRom($currentRom = null)
    {
        // validation for constraint: string
        if (!is_null($currentRom) && !is_string($currentRom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currentRom, true), gettype($currentRom)), __LINE__);
        }
        $this->CurrentRom = $currentRom;
        return $this;
    }
    /**
     * Get RamHomeNumber value
     * @return string|null
     */
    public function getRamHomeNumber()
    {
        return $this->RamHomeNumber;
    }
    /**
     * Set RamHomeNumber value
     * @param string $ramHomeNumber
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRamHomeNumber($ramHomeNumber = null)
    {
        // validation for constraint: string
        if (!is_null($ramHomeNumber) && !is_string($ramHomeNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ramHomeNumber, true), gettype($ramHomeNumber)), __LINE__);
        }
        $this->RamHomeNumber = $ramHomeNumber;
        return $this;
    }
    /**
     * Get FirmwareVersion value
     * @return string|null
     */
    public function getFirmwareVersion()
    {
        return $this->FirmwareVersion;
    }
    /**
     * Set FirmwareVersion value
     * @param string $firmwareVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setFirmwareVersion($firmwareVersion = null)
    {
        // validation for constraint: string
        if (!is_null($firmwareVersion) && !is_string($firmwareVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firmwareVersion, true), gettype($firmwareVersion)), __LINE__);
        }
        $this->FirmwareVersion = $firmwareVersion;
        return $this;
    }
    /**
     * Get OSVersion value
     * @return string|null
     */
    public function getOSVersion()
    {
        return $this->OSVersion;
    }
    /**
     * Set OSVersion value
     * @param string $oSVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setOSVersion($oSVersion = null)
    {
        // validation for constraint: string
        if (!is_null($oSVersion) && !is_string($oSVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($oSVersion, true), gettype($oSVersion)), __LINE__);
        }
        $this->OSVersion = $oSVersion;
        return $this;
    }
    /**
     * Get ImageVersion value
     * @return string|null
     */
    public function getImageVersion()
    {
        return $this->ImageVersion;
    }
    /**
     * Set ImageVersion value
     * @param string $imageVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setImageVersion($imageVersion = null)
    {
        // validation for constraint: string
        if (!is_null($imageVersion) && !is_string($imageVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($imageVersion, true), gettype($imageVersion)), __LINE__);
        }
        $this->ImageVersion = $imageVersion;
        return $this;
    }
    /**
     * Get EPromVersion value
     * @return string|null
     */
    public function getEPromVersion()
    {
        return $this->EPromVersion;
    }
    /**
     * Set EPromVersion value
     * @param string $ePromVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setEPromVersion($ePromVersion = null)
    {
        // validation for constraint: string
        if (!is_null($ePromVersion) && !is_string($ePromVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ePromVersion, true), gettype($ePromVersion)), __LINE__);
        }
        $this->EPromVersion = $ePromVersion;
        return $this;
    }
    /**
     * Get BootloaderVersion value
     * @return string|null
     */
    public function getBootloaderVersion()
    {
        return $this->BootloaderVersion;
    }
    /**
     * Set BootloaderVersion value
     * @param string $bootloaderVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setBootloaderVersion($bootloaderVersion = null)
    {
        // validation for constraint: string
        if (!is_null($bootloaderVersion) && !is_string($bootloaderVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bootloaderVersion, true), gettype($bootloaderVersion)), __LINE__);
        }
        $this->BootloaderVersion = $bootloaderVersion;
        return $this;
    }
    /**
     * Get CPLDVersion value
     * @return string|null
     */
    public function getCPLDVersion()
    {
        return $this->CPLDVersion;
    }
    /**
     * Set CPLDVersion value
     * @param string $cPLDVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setCPLDVersion($cPLDVersion = null)
    {
        // validation for constraint: string
        if (!is_null($cPLDVersion) && !is_string($cPLDVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cPLDVersion, true), gettype($cPLDVersion)), __LINE__);
        }
        $this->CPLDVersion = $cPLDVersion;
        return $this;
    }
    /**
     * Get IVVersion value
     * @return string|null
     */
    public function getIVVersion()
    {
        return $this->IVVersion;
    }
    /**
     * Set IVVersion value
     * @param string $iVVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setIVVersion($iVVersion = null)
    {
        // validation for constraint: string
        if (!is_null($iVVersion) && !is_string($iVVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iVVersion, true), gettype($iVVersion)), __LINE__);
        }
        $this->IVVersion = $iVVersion;
        return $this;
    }
    /**
     * Get ISSubversion value
     * @return string|null
     */
    public function getISSubversion()
    {
        return $this->ISSubversion;
    }
    /**
     * Set ISSubversion value
     * @param string $iSSubversion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setISSubversion($iSSubversion = null)
    {
        // validation for constraint: string
        if (!is_null($iSSubversion) && !is_string($iSSubversion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iSSubversion, true), gettype($iSSubversion)), __LINE__);
        }
        $this->ISSubversion = $iSSubversion;
        return $this;
    }
    /**
     * Get CanVersion value
     * @return string|null
     */
    public function getCanVersion()
    {
        return $this->CanVersion;
    }
    /**
     * Set CanVersion value
     * @param string $canVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setCanVersion($canVersion = null)
    {
        // validation for constraint: string
        if (!is_null($canVersion) && !is_string($canVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($canVersion, true), gettype($canVersion)), __LINE__);
        }
        $this->CanVersion = $canVersion;
        return $this;
    }
    /**
     * Get UniversalTachoInterfaceVersion value
     * @return string|null
     */
    public function getUniversalTachoInterfaceVersion()
    {
        return $this->UniversalTachoInterfaceVersion;
    }
    /**
     * Set UniversalTachoInterfaceVersion value
     * @param string $universalTachoInterfaceVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setUniversalTachoInterfaceVersion($universalTachoInterfaceVersion = null)
    {
        // validation for constraint: string
        if (!is_null($universalTachoInterfaceVersion) && !is_string($universalTachoInterfaceVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($universalTachoInterfaceVersion, true), gettype($universalTachoInterfaceVersion)), __LINE__);
        }
        $this->UniversalTachoInterfaceVersion = $universalTachoInterfaceVersion;
        return $this;
    }
    /**
     * Get BootloaderMajorMinor value
     * @return string|null
     */
    public function getBootloaderMajorMinor()
    {
        return $this->BootloaderMajorMinor;
    }
    /**
     * Set BootloaderMajorMinor value
     * @param string $bootloaderMajorMinor
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setBootloaderMajorMinor($bootloaderMajorMinor = null)
    {
        // validation for constraint: string
        if (!is_null($bootloaderMajorMinor) && !is_string($bootloaderMajorMinor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bootloaderMajorMinor, true), gettype($bootloaderMajorMinor)), __LINE__);
        }
        $this->BootloaderMajorMinor = $bootloaderMajorMinor;
        return $this;
    }
    /**
     * Get ApplicationMajorMinor value
     * @return string|null
     */
    public function getApplicationMajorMinor()
    {
        return $this->ApplicationMajorMinor;
    }
    /**
     * Set ApplicationMajorMinor value
     * @param string $applicationMajorMinor
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setApplicationMajorMinor($applicationMajorMinor = null)
    {
        // validation for constraint: string
        if (!is_null($applicationMajorMinor) && !is_string($applicationMajorMinor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicationMajorMinor, true), gettype($applicationMajorMinor)), __LINE__);
        }
        $this->ApplicationMajorMinor = $applicationMajorMinor;
        return $this;
    }
    /**
     * Get CompactUnitVersion value
     * @return string|null
     */
    public function getCompactUnitVersion()
    {
        return $this->CompactUnitVersion;
    }
    /**
     * Set CompactUnitVersion value
     * @param string $compactUnitVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setCompactUnitVersion($compactUnitVersion = null)
    {
        // validation for constraint: string
        if (!is_null($compactUnitVersion) && !is_string($compactUnitVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($compactUnitVersion, true), gettype($compactUnitVersion)), __LINE__);
        }
        $this->CompactUnitVersion = $compactUnitVersion;
        return $this;
    }
    /**
     * Get PlanningReadConfirmation value
     * @return string|null
     */
    public function getPlanningReadConfirmation()
    {
        return $this->PlanningReadConfirmation;
    }
    /**
     * Set PlanningReadConfirmation value
     * @param string $planningReadConfirmation
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPlanningReadConfirmation($planningReadConfirmation = null)
    {
        // validation for constraint: string
        if (!is_null($planningReadConfirmation) && !is_string($planningReadConfirmation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($planningReadConfirmation, true), gettype($planningReadConfirmation)), __LINE__);
        }
        $this->PlanningReadConfirmation = $planningReadConfirmation;
        return $this;
    }
    /**
     * Get SpeedSource value
     * @return string|null
     */
    public function getSpeedSource()
    {
        return $this->SpeedSource;
    }
    /**
     * Set SpeedSource value
     * @param string $speedSource
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setSpeedSource($speedSource = null)
    {
        // validation for constraint: string
        if (!is_null($speedSource) && !is_string($speedSource)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($speedSource, true), gettype($speedSource)), __LINE__);
        }
        $this->SpeedSource = $speedSource;
        return $this;
    }
    /**
     * Get RpmSource value
     * @return string|null
     */
    public function getRpmSource()
    {
        return $this->RpmSource;
    }
    /**
     * Set RpmSource value
     * @param string $rpmSource
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRpmSource($rpmSource = null)
    {
        // validation for constraint: string
        if (!is_null($rpmSource) && !is_string($rpmSource)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rpmSource, true), gettype($rpmSource)), __LINE__);
        }
        $this->RpmSource = $rpmSource;
        return $this;
    }
    /**
     * Get PulsSettingIndication value
     * @return string|null
     */
    public function getPulsSettingIndication()
    {
        return $this->PulsSettingIndication;
    }
    /**
     * Set PulsSettingIndication value
     * @param string $pulsSettingIndication
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPulsSettingIndication($pulsSettingIndication = null)
    {
        // validation for constraint: string
        if (!is_null($pulsSettingIndication) && !is_string($pulsSettingIndication)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pulsSettingIndication, true), gettype($pulsSettingIndication)), __LINE__);
        }
        $this->PulsSettingIndication = $pulsSettingIndication;
        return $this;
    }
    /**
     * Get PulsSettingValue value
     * @return string|null
     */
    public function getPulsSettingValue()
    {
        return $this->PulsSettingValue;
    }
    /**
     * Set PulsSettingValue value
     * @param string $pulsSettingValue
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPulsSettingValue($pulsSettingValue = null)
    {
        // validation for constraint: string
        if (!is_null($pulsSettingValue) && !is_string($pulsSettingValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pulsSettingValue, true), gettype($pulsSettingValue)), __LINE__);
        }
        $this->PulsSettingValue = $pulsSettingValue;
        return $this;
    }
    /**
     * Get PulsSettingMileageLastChanged value
     * @return string|null
     */
    public function getPulsSettingMileageLastChanged()
    {
        return $this->PulsSettingMileageLastChanged;
    }
    /**
     * Set PulsSettingMileageLastChanged value
     * @param string $pulsSettingMileageLastChanged
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPulsSettingMileageLastChanged($pulsSettingMileageLastChanged = null)
    {
        // validation for constraint: string
        if (!is_null($pulsSettingMileageLastChanged) && !is_string($pulsSettingMileageLastChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pulsSettingMileageLastChanged, true), gettype($pulsSettingMileageLastChanged)), __LINE__);
        }
        $this->PulsSettingMileageLastChanged = $pulsSettingMileageLastChanged;
        return $this;
    }
    /**
     * Get PulSettingDateTimeLastChange value
     * @return string|null
     */
    public function getPulSettingDateTimeLastChange()
    {
        return $this->PulSettingDateTimeLastChange;
    }
    /**
     * Set PulSettingDateTimeLastChange value
     * @param string $pulSettingDateTimeLastChange
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPulSettingDateTimeLastChange($pulSettingDateTimeLastChange = null)
    {
        // validation for constraint: string
        if (!is_null($pulSettingDateTimeLastChange) && !is_string($pulSettingDateTimeLastChange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pulSettingDateTimeLastChange, true), gettype($pulSettingDateTimeLastChange)), __LINE__);
        }
        $this->PulSettingDateTimeLastChange = $pulSettingDateTimeLastChange;
        return $this;
    }
    /**
     * Get KmProtocolSetting value
     * @return string|null
     */
    public function getKmProtocolSetting()
    {
        return $this->KmProtocolSetting;
    }
    /**
     * Set KmProtocolSetting value
     * @param string $kmProtocolSetting
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setKmProtocolSetting($kmProtocolSetting = null)
    {
        // validation for constraint: string
        if (!is_null($kmProtocolSetting) && !is_string($kmProtocolSetting)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kmProtocolSetting, true), gettype($kmProtocolSetting)), __LINE__);
        }
        $this->KmProtocolSetting = $kmProtocolSetting;
        return $this;
    }
    /**
     * Get VKFreeNumber value
     * @return string|null
     */
    public function getVKFreeNumber()
    {
        return $this->VKFreeNumber;
    }
    /**
     * Set VKFreeNumber value
     * @param string $vKFreeNumber
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setVKFreeNumber($vKFreeNumber = null)
    {
        // validation for constraint: string
        if (!is_null($vKFreeNumber) && !is_string($vKFreeNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vKFreeNumber, true), gettype($vKFreeNumber)), __LINE__);
        }
        $this->VKFreeNumber = $vKFreeNumber;
        return $this;
    }
    /**
     * Get VKRefuseIncoming value
     * @return string|null
     */
    public function getVKRefuseIncoming()
    {
        return $this->VKRefuseIncoming;
    }
    /**
     * Set VKRefuseIncoming value
     * @param string $vKRefuseIncoming
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setVKRefuseIncoming($vKRefuseIncoming = null)
    {
        // validation for constraint: string
        if (!is_null($vKRefuseIncoming) && !is_string($vKRefuseIncoming)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vKRefuseIncoming, true), gettype($vKRefuseIncoming)), __LINE__);
        }
        $this->VKRefuseIncoming = $vKRefuseIncoming;
        return $this;
    }
    /**
     * Get VKRefuseCalling value
     * @return string|null
     */
    public function getVKRefuseCalling()
    {
        return $this->VKRefuseCalling;
    }
    /**
     * Set VKRefuseCalling value
     * @param string $vKRefuseCalling
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setVKRefuseCalling($vKRefuseCalling = null)
    {
        // validation for constraint: string
        if (!is_null($vKRefuseCalling) && !is_string($vKRefuseCalling)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vKRefuseCalling, true), gettype($vKRefuseCalling)), __LINE__);
        }
        $this->VKRefuseCalling = $vKRefuseCalling;
        return $this;
    }
    /**
     * Get ComPorts value
     * @return string|null
     */
    public function getComPorts()
    {
        return $this->ComPorts;
    }
    /**
     * Set ComPorts value
     * @param string $comPorts
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setComPorts($comPorts = null)
    {
        // validation for constraint: string
        if (!is_null($comPorts) && !is_string($comPorts)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comPorts, true), gettype($comPorts)), __LINE__);
        }
        $this->ComPorts = $comPorts;
        return $this;
    }
    /**
     * Get ObcLoudness value
     * @return string|null
     */
    public function getObcLoudness()
    {
        return $this->ObcLoudness;
    }
    /**
     * Set ObcLoudness value
     * @param string $obcLoudness
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setObcLoudness($obcLoudness = null)
    {
        // validation for constraint: string
        if (!is_null($obcLoudness) && !is_string($obcLoudness)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($obcLoudness, true), gettype($obcLoudness)), __LINE__);
        }
        $this->ObcLoudness = $obcLoudness;
        return $this;
    }
    /**
     * Get TechParamFile value
     * @return string|null
     */
    public function getTechParamFile()
    {
        return $this->TechParamFile;
    }
    /**
     * Set TechParamFile value
     * @param string $techParamFile
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTechParamFile($techParamFile = null)
    {
        // validation for constraint: string
        if (!is_null($techParamFile) && !is_string($techParamFile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($techParamFile, true), gettype($techParamFile)), __LINE__);
        }
        $this->TechParamFile = $techParamFile;
        return $this;
    }
    /**
     * Get TachoStatus value
     * @return string|null
     */
    public function getTachoStatus()
    {
        return $this->TachoStatus;
    }
    /**
     * Set TachoStatus value
     * @param string $tachoStatus
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTachoStatus($tachoStatus = null)
    {
        // validation for constraint: string
        if (!is_null($tachoStatus) && !is_string($tachoStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tachoStatus, true), gettype($tachoStatus)), __LINE__);
        }
        $this->TachoStatus = $tachoStatus;
        return $this;
    }
    /**
     * Get RibasVersion value
     * @return string|null
     */
    public function getRibasVersion()
    {
        return $this->RibasVersion;
    }
    /**
     * Set RibasVersion value
     * @param string $ribasVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasVersion($ribasVersion = null)
    {
        // validation for constraint: string
        if (!is_null($ribasVersion) && !is_string($ribasVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasVersion, true), gettype($ribasVersion)), __LINE__);
        }
        $this->RibasVersion = $ribasVersion;
        return $this;
    }
    /**
     * Get RibasRevvingWarning value
     * @return string|null
     */
    public function getRibasRevvingWarning()
    {
        return $this->RibasRevvingWarning;
    }
    /**
     * Set RibasRevvingWarning value
     * @param string $ribasRevvingWarning
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasRevvingWarning($ribasRevvingWarning = null)
    {
        // validation for constraint: string
        if (!is_null($ribasRevvingWarning) && !is_string($ribasRevvingWarning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasRevvingWarning, true), gettype($ribasRevvingWarning)), __LINE__);
        }
        $this->RibasRevvingWarning = $ribasRevvingWarning;
        return $this;
    }
    /**
     * Get RibasRevvingMax value
     * @return string|null
     */
    public function getRibasRevvingMax()
    {
        return $this->RibasRevvingMax;
    }
    /**
     * Set RibasRevvingMax value
     * @param string $ribasRevvingMax
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasRevvingMax($ribasRevvingMax = null)
    {
        // validation for constraint: string
        if (!is_null($ribasRevvingMax) && !is_string($ribasRevvingMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasRevvingMax, true), gettype($ribasRevvingMax)), __LINE__);
        }
        $this->RibasRevvingMax = $ribasRevvingMax;
        return $this;
    }
    /**
     * Get RibasIdlingWarning value
     * @return string|null
     */
    public function getRibasIdlingWarning()
    {
        return $this->RibasIdlingWarning;
    }
    /**
     * Set RibasIdlingWarning value
     * @param string $ribasIdlingWarning
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasIdlingWarning($ribasIdlingWarning = null)
    {
        // validation for constraint: string
        if (!is_null($ribasIdlingWarning) && !is_string($ribasIdlingWarning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasIdlingWarning, true), gettype($ribasIdlingWarning)), __LINE__);
        }
        $this->RibasIdlingWarning = $ribasIdlingWarning;
        return $this;
    }
    /**
     * Get RibasIdlingMax value
     * @return string|null
     */
    public function getRibasIdlingMax()
    {
        return $this->RibasIdlingMax;
    }
    /**
     * Set RibasIdlingMax value
     * @param string $ribasIdlingMax
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasIdlingMax($ribasIdlingMax = null)
    {
        // validation for constraint: string
        if (!is_null($ribasIdlingMax) && !is_string($ribasIdlingMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasIdlingMax, true), gettype($ribasIdlingMax)), __LINE__);
        }
        $this->RibasIdlingMax = $ribasIdlingMax;
        return $this;
    }
    /**
     * Get RibasBrakingWarning value
     * @return string|null
     */
    public function getRibasBrakingWarning()
    {
        return $this->RibasBrakingWarning;
    }
    /**
     * Set RibasBrakingWarning value
     * @param string $ribasBrakingWarning
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasBrakingWarning($ribasBrakingWarning = null)
    {
        // validation for constraint: string
        if (!is_null($ribasBrakingWarning) && !is_string($ribasBrakingWarning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasBrakingWarning, true), gettype($ribasBrakingWarning)), __LINE__);
        }
        $this->RibasBrakingWarning = $ribasBrakingWarning;
        return $this;
    }
    /**
     * Get RibasBrakingMax value
     * @return string|null
     */
    public function getRibasBrakingMax()
    {
        return $this->RibasBrakingMax;
    }
    /**
     * Set RibasBrakingMax value
     * @param string $ribasBrakingMax
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasBrakingMax($ribasBrakingMax = null)
    {
        // validation for constraint: string
        if (!is_null($ribasBrakingMax) && !is_string($ribasBrakingMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasBrakingMax, true), gettype($ribasBrakingMax)), __LINE__);
        }
        $this->RibasBrakingMax = $ribasBrakingMax;
        return $this;
    }
    /**
     * Get RibasAccelerationWarning value
     * @return string|null
     */
    public function getRibasAccelerationWarning()
    {
        return $this->RibasAccelerationWarning;
    }
    /**
     * Set RibasAccelerationWarning value
     * @param string $ribasAccelerationWarning
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasAccelerationWarning($ribasAccelerationWarning = null)
    {
        // validation for constraint: string
        if (!is_null($ribasAccelerationWarning) && !is_string($ribasAccelerationWarning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasAccelerationWarning, true), gettype($ribasAccelerationWarning)), __LINE__);
        }
        $this->RibasAccelerationWarning = $ribasAccelerationWarning;
        return $this;
    }
    /**
     * Get RibasAccelerationMax value
     * @return string|null
     */
    public function getRibasAccelerationMax()
    {
        return $this->RibasAccelerationMax;
    }
    /**
     * Set RibasAccelerationMax value
     * @param string $ribasAccelerationMax
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasAccelerationMax($ribasAccelerationMax = null)
    {
        // validation for constraint: string
        if (!is_null($ribasAccelerationMax) && !is_string($ribasAccelerationMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasAccelerationMax, true), gettype($ribasAccelerationMax)), __LINE__);
        }
        $this->RibasAccelerationMax = $ribasAccelerationMax;
        return $this;
    }
    /**
     * Get RibasSpeedWarning value
     * @return string|null
     */
    public function getRibasSpeedWarning()
    {
        return $this->RibasSpeedWarning;
    }
    /**
     * Set RibasSpeedWarning value
     * @param string $ribasSpeedWarning
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasSpeedWarning($ribasSpeedWarning = null)
    {
        // validation for constraint: string
        if (!is_null($ribasSpeedWarning) && !is_string($ribasSpeedWarning)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasSpeedWarning, true), gettype($ribasSpeedWarning)), __LINE__);
        }
        $this->RibasSpeedWarning = $ribasSpeedWarning;
        return $this;
    }
    /**
     * Get RibasSpeedMax value
     * @return string|null
     */
    public function getRibasSpeedMax()
    {
        return $this->RibasSpeedMax;
    }
    /**
     * Set RibasSpeedMax value
     * @param string $ribasSpeedMax
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setRibasSpeedMax($ribasSpeedMax = null)
    {
        // validation for constraint: string
        if (!is_null($ribasSpeedMax) && !is_string($ribasSpeedMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ribasSpeedMax, true), gettype($ribasSpeedMax)), __LINE__);
        }
        $this->RibasSpeedMax = $ribasSpeedMax;
        return $this;
    }
    /**
     * Get PlanningCleaningVersion value
     * @return string|null
     */
    public function getPlanningCleaningVersion()
    {
        return $this->PlanningCleaningVersion;
    }
    /**
     * Set PlanningCleaningVersion value
     * @param string $planningCleaningVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPlanningCleaningVersion($planningCleaningVersion = null)
    {
        // validation for constraint: string
        if (!is_null($planningCleaningVersion) && !is_string($planningCleaningVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($planningCleaningVersion, true), gettype($planningCleaningVersion)), __LINE__);
        }
        $this->PlanningCleaningVersion = $planningCleaningVersion;
        return $this;
    }
    /**
     * Get PlanningCleaningTimeoutNotCheckedOff value
     * @return string|null
     */
    public function getPlanningCleaningTimeoutNotCheckedOff()
    {
        return $this->PlanningCleaningTimeoutNotCheckedOff;
    }
    /**
     * Set PlanningCleaningTimeoutNotCheckedOff value
     * @param string $planningCleaningTimeoutNotCheckedOff
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPlanningCleaningTimeoutNotCheckedOff($planningCleaningTimeoutNotCheckedOff = null)
    {
        // validation for constraint: string
        if (!is_null($planningCleaningTimeoutNotCheckedOff) && !is_string($planningCleaningTimeoutNotCheckedOff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($planningCleaningTimeoutNotCheckedOff, true), gettype($planningCleaningTimeoutNotCheckedOff)), __LINE__);
        }
        $this->PlanningCleaningTimeoutNotCheckedOff = $planningCleaningTimeoutNotCheckedOff;
        return $this;
    }
    /**
     * Get PlanningCleaningTimeoutcheckedOff value
     * @return string|null
     */
    public function getPlanningCleaningTimeoutcheckedOff()
    {
        return $this->PlanningCleaningTimeoutcheckedOff;
    }
    /**
     * Set PlanningCleaningTimeoutcheckedOff value
     * @param string $planningCleaningTimeoutcheckedOff
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPlanningCleaningTimeoutcheckedOff($planningCleaningTimeoutcheckedOff = null)
    {
        // validation for constraint: string
        if (!is_null($planningCleaningTimeoutcheckedOff) && !is_string($planningCleaningTimeoutcheckedOff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($planningCleaningTimeoutcheckedOff, true), gettype($planningCleaningTimeoutcheckedOff)), __LINE__);
        }
        $this->PlanningCleaningTimeoutcheckedOff = $planningCleaningTimeoutcheckedOff;
        return $this;
    }
    /**
     * Get PopupGeofencingAlarmsVersion value
     * @return string|null
     */
    public function getPopupGeofencingAlarmsVersion()
    {
        return $this->PopupGeofencingAlarmsVersion;
    }
    /**
     * Set PopupGeofencingAlarmsVersion value
     * @param string $popupGeofencingAlarmsVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPopupGeofencingAlarmsVersion($popupGeofencingAlarmsVersion = null)
    {
        // validation for constraint: string
        if (!is_null($popupGeofencingAlarmsVersion) && !is_string($popupGeofencingAlarmsVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($popupGeofencingAlarmsVersion, true), gettype($popupGeofencingAlarmsVersion)), __LINE__);
        }
        $this->PopupGeofencingAlarmsVersion = $popupGeofencingAlarmsVersion;
        return $this;
    }
    /**
     * Get PopupGeofencingAlarmsStatus value
     * @return string|null
     */
    public function getPopupGeofencingAlarmsStatus()
    {
        return $this->PopupGeofencingAlarmsStatus;
    }
    /**
     * Set PopupGeofencingAlarmsStatus value
     * @param string $popupGeofencingAlarmsStatus
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPopupGeofencingAlarmsStatus($popupGeofencingAlarmsStatus = null)
    {
        // validation for constraint: string
        if (!is_null($popupGeofencingAlarmsStatus) && !is_string($popupGeofencingAlarmsStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($popupGeofencingAlarmsStatus, true), gettype($popupGeofencingAlarmsStatus)), __LINE__);
        }
        $this->PopupGeofencingAlarmsStatus = $popupGeofencingAlarmsStatus;
        return $this;
    }
    /**
     * Get PopupTextMessagesVersion value
     * @return string|null
     */
    public function getPopupTextMessagesVersion()
    {
        return $this->PopupTextMessagesVersion;
    }
    /**
     * Set PopupTextMessagesVersion value
     * @param string $popupTextMessagesVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPopupTextMessagesVersion($popupTextMessagesVersion = null)
    {
        // validation for constraint: string
        if (!is_null($popupTextMessagesVersion) && !is_string($popupTextMessagesVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($popupTextMessagesVersion, true), gettype($popupTextMessagesVersion)), __LINE__);
        }
        $this->PopupTextMessagesVersion = $popupTextMessagesVersion;
        return $this;
    }
    /**
     * Get PopupTextMessagesStatus value
     * @return string|null
     */
    public function getPopupTextMessagesStatus()
    {
        return $this->PopupTextMessagesStatus;
    }
    /**
     * Set PopupTextMessagesStatus value
     * @param string $popupTextMessagesStatus
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setPopupTextMessagesStatus($popupTextMessagesStatus = null)
    {
        // validation for constraint: string
        if (!is_null($popupTextMessagesStatus) && !is_string($popupTextMessagesStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($popupTextMessagesStatus, true), gettype($popupTextMessagesStatus)), __LINE__);
        }
        $this->PopupTextMessagesStatus = $popupTextMessagesStatus;
        return $this;
    }
    /**
     * Get LoginManagerVersion value
     * @return string|null
     */
    public function getLoginManagerVersion()
    {
        return $this->LoginManagerVersion;
    }
    /**
     * Set LoginManagerVersion value
     * @param string $loginManagerVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setLoginManagerVersion($loginManagerVersion = null)
    {
        // validation for constraint: string
        if (!is_null($loginManagerVersion) && !is_string($loginManagerVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loginManagerVersion, true), gettype($loginManagerVersion)), __LINE__);
        }
        $this->LoginManagerVersion = $loginManagerVersion;
        return $this;
    }
    /**
     * Get LoginManagerTimeout value
     * @return string|null
     */
    public function getLoginManagerTimeout()
    {
        return $this->LoginManagerTimeout;
    }
    /**
     * Set LoginManagerTimeout value
     * @param string $loginManagerTimeout
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setLoginManagerTimeout($loginManagerTimeout = null)
    {
        // validation for constraint: string
        if (!is_null($loginManagerTimeout) && !is_string($loginManagerTimeout)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loginManagerTimeout, true), gettype($loginManagerTimeout)), __LINE__);
        }
        $this->LoginManagerTimeout = $loginManagerTimeout;
        return $this;
    }
    /**
     * Get TCGFormatVersion value
     * @return string|null
     */
    public function getTCGFormatVersion()
    {
        return $this->TCGFormatVersion;
    }
    /**
     * Set TCGFormatVersion value
     * @param string $tCGFormatVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTCGFormatVersion($tCGFormatVersion = null)
    {
        // validation for constraint: string
        if (!is_null($tCGFormatVersion) && !is_string($tCGFormatVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tCGFormatVersion, true), gettype($tCGFormatVersion)), __LINE__);
        }
        $this->TCGFormatVersion = $tCGFormatVersion;
        return $this;
    }
    /**
     * Get TCGSameIpAsFtp value
     * @return string|null
     */
    public function getTCGSameIpAsFtp()
    {
        return $this->TCGSameIpAsFtp;
    }
    /**
     * Set TCGSameIpAsFtp value
     * @param string $tCGSameIpAsFtp
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTCGSameIpAsFtp($tCGSameIpAsFtp = null)
    {
        // validation for constraint: string
        if (!is_null($tCGSameIpAsFtp) && !is_string($tCGSameIpAsFtp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tCGSameIpAsFtp, true), gettype($tCGSameIpAsFtp)), __LINE__);
        }
        $this->TCGSameIpAsFtp = $tCGSameIpAsFtp;
        return $this;
    }
    /**
     * Get TCGIp value
     * @return string|null
     */
    public function getTCGIp()
    {
        return $this->TCGIp;
    }
    /**
     * Set TCGIp value
     * @param string $tCGIp
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTCGIp($tCGIp = null)
    {
        // validation for constraint: string
        if (!is_null($tCGIp) && !is_string($tCGIp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tCGIp, true), gettype($tCGIp)), __LINE__);
        }
        $this->TCGIp = $tCGIp;
        return $this;
    }
    /**
     * Get AgrNumber value
     * @return string|null
     */
    public function getAgrNumber()
    {
        return $this->AgrNumber;
    }
    /**
     * Set AgrNumber value
     * @param string $agrNumber
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setAgrNumber($agrNumber = null)
    {
        // validation for constraint: string
        if (!is_null($agrNumber) && !is_string($agrNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agrNumber, true), gettype($agrNumber)), __LINE__);
        }
        $this->AgrNumber = $agrNumber;
        return $this;
    }
    /**
     * Get TemperaturTopbarVersion value
     * @return string|null
     */
    public function getTemperaturTopbarVersion()
    {
        return $this->TemperaturTopbarVersion;
    }
    /**
     * Set TemperaturTopbarVersion value
     * @param string $temperaturTopbarVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTemperaturTopbarVersion($temperaturTopbarVersion = null)
    {
        // validation for constraint: string
        if (!is_null($temperaturTopbarVersion) && !is_string($temperaturTopbarVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($temperaturTopbarVersion, true), gettype($temperaturTopbarVersion)), __LINE__);
        }
        $this->TemperaturTopbarVersion = $temperaturTopbarVersion;
        return $this;
    }
    /**
     * Get TemperatureTopbarStatus value
     * @return string|null
     */
    public function getTemperatureTopbarStatus()
    {
        return $this->TemperatureTopbarStatus;
    }
    /**
     * Set TemperatureTopbarStatus value
     * @param string $temperatureTopbarStatus
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setTemperatureTopbarStatus($temperatureTopbarStatus = null)
    {
        // validation for constraint: string
        if (!is_null($temperatureTopbarStatus) && !is_string($temperatureTopbarStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($temperatureTopbarStatus, true), gettype($temperatureTopbarStatus)), __LINE__);
        }
        $this->TemperatureTopbarStatus = $temperatureTopbarStatus;
        return $this;
    }
    /**
     * Get SendDocumentsVersion value
     * @return string|null
     */
    public function getSendDocumentsVersion()
    {
        return $this->SendDocumentsVersion;
    }
    /**
     * Set SendDocumentsVersion value
     * @param string $sendDocumentsVersion
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setSendDocumentsVersion($sendDocumentsVersion = null)
    {
        // validation for constraint: string
        if (!is_null($sendDocumentsVersion) && !is_string($sendDocumentsVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sendDocumentsVersion, true), gettype($sendDocumentsVersion)), __LINE__);
        }
        $this->SendDocumentsVersion = $sendDocumentsVersion;
        return $this;
    }
    /**
     * Get SendDocumentsStatus value
     * @return string|null
     */
    public function getSendDocumentsStatus()
    {
        return $this->SendDocumentsStatus;
    }
    /**
     * Set SendDocumentsStatus value
     * @param string $sendDocumentsStatus
     * @return \StructType\VehicleConfigurationDiagnostics
     */
    public function setSendDocumentsStatus($sendDocumentsStatus = null)
    {
        // validation for constraint: string
        if (!is_null($sendDocumentsStatus) && !is_string($sendDocumentsStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sendDocumentsStatus, true), gettype($sendDocumentsStatus)), __LINE__);
        }
        $this->SendDocumentsStatus = $sendDocumentsStatus;
        return $this;
    }
}
